
function PDA_Warlock_GetItemData(slotID)
	local itemLink = GetInventoryItemLink("Player", slotID)
	if (itemLink == nil) then return 0, 0, 0, 0, 0, 0 end
	PDA_Warlock_HiddenTooltip:SetHyperlink(itemLink)
	
	local int = 0
	local hit = 0
	local crit = 0
	local sp = 0
	local ssp = 0
	local fsp = 0
	
	for i=1, PDA_Warlock_HiddenTooltip:NumLines(), 1 do
		local tempText = _G["PDA_Warlock_HiddenTooltipTextLeft"..i]:GetText()
		-- SKIP IF SET BONUS --
		if not(tempText:find("Set")) then
			if (tempText:find("damage and healing done by magical")) then
				local value, count = tempText:gsub("%D+", "")
				sp = sp + tonumber(value)
			elseif (tempText:find("damage done by Shadow spells")) then
				local value, count = tempText:gsub("%D+", "")
				ssp = ssp + tonumber(value)
			elseif (tempText:find("damage done by Fire spells")) then
				local value, count = tempText:gsub("%D+", "")
				fsp = fsp + tonumber(value)
			elseif (tempText:find("Nature Spell Damage")) then
			elseif (tempText:find("Frost Spell Damage")) then
			elseif (tempText:find("Arcane Spell Damage")) then
			elseif (tempText:find("Shadow Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				ssp = sp + tonumber(value)
			elseif (tempText:find("Fire Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				fsp = sp + tonumber(value)
			elseif (tempText:find("Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				sp = sp + tonumber(value)
			elseif (tempText:find("critical strike with spells")) then
				local value, count = tempText:gsub("%D+", "")
				crit = crit + tonumber(value)
			elseif (tempText:find("hit with spells")) then
				local value, count = tempText:gsub("%D+", "")
				hit = hit + tonumber(value)
			elseif (tempText:find("Intellect")) then
				local value, count = tempText:gsub("%D+", "")
				int = int + tonumber(value)
			elseif (tempText:find("All Stats")) then
				local value, count = tempText:gsub("%D+", "")
				int = int + tonumber(value)
			end
		end
	end
	
	return int, hit, crit, sp, ssp, fsp
end

function PDA_Warlock_GetSetBonusData()
	local dreadmist = 0
	local deathmist = 0
	local nemesis = 0
	
	for i=1, 19, 1 do
		local itemLink = GetInventoryItemLink("Player", i)
		if not(itemLink == nil) then
			PDA_Warlock_HiddenTooltip:SetHyperlink(itemLink)
			local firstline = _G["PDA_Warlock_HiddenTooltipTextLeft".."1"]:GetText()
			if (firstline:find("Dreadmist")) then
				dreadmist = dreadmist + 1
			elseif (firstline:find("Deathmist")) then
				deathmist = deathmist + 1
			elseif (firstline:find("Nemesis")) then
				nemesis = nemesis + 1
			end
		end
	end
	
	local int = 0
	local hit = 0
	local crit = 0
	local sp = 0
	local ssp = 0
	local fsp = 0
	
	if (dreadmist >= 4) then
		sp = sp + 23
	end
	
	if (deathmist >= 6) then
		sp = sp + 23
	end
	
	if (nemesis >= 3) then
		sp = sp + 23
	end
	
	return int, hit, crit, sp, ssp, fsp
end

function PDA_Warlock_SetSlotValue(slot, int, hit, crit, sp, ssp, fsp)
	slot.Int:SetValue(int)
	slot.Hit:SetValue(hit)
	slot.Crit:SetValue(crit)
	slot.SP:SetValue(sp)
	slot.SSP:SetValue(ssp)
	slot.FSP:SetValue(fsp)
end

function PDA_Warlock_AutoFill()
	PDA_Warlock_SetSlotValue(PDA_Warlock_Head, PDA_Warlock_GetItemData(1))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Neck, PDA_Warlock_GetItemData(2))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Shoulder, PDA_Warlock_GetItemData(3))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Back, PDA_Warlock_GetItemData(15))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Chest, PDA_Warlock_GetItemData(5))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Shirt, PDA_Warlock_GetItemData(4))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Tabard, PDA_Warlock_GetItemData(19))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Wrist, PDA_Warlock_GetItemData(9))
	
	PDA_Warlock_SetSlotValue(PDA_Warlock_Hands, PDA_Warlock_GetItemData(10))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Waist, PDA_Warlock_GetItemData(6))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Legs, PDA_Warlock_GetItemData(7))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Feet, PDA_Warlock_GetItemData(8))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Finger1, PDA_Warlock_GetItemData(11))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Finger2, PDA_Warlock_GetItemData(12))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Trinket1, PDA_Warlock_GetItemData(13))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Trinket2, PDA_Warlock_GetItemData(14))

	PDA_Warlock_SetSlotValue(PDA_Warlock_MainHand, PDA_Warlock_GetItemData(16))
	PDA_Warlock_SetSlotValue(PDA_Warlock_OffHand, PDA_Warlock_GetItemData(17))
	PDA_Warlock_SetSlotValue(PDA_Warlock_Wand, PDA_Warlock_GetItemData(18))
	
	PDA_Warlock_SetSlotValue(PDA_Warlock_SetBonus, PDA_Warlock_GetSetBonusData())
end

function PDA_Warlock_Clear()
	PDA_Warlock_SetSlotValue(PDA_Warlock_Head, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Neck, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Shoulder, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Back, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Chest, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Shirt, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Tabard, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Wrist, 0, 0, 0, 0, 0, 0)
	
	PDA_Warlock_SetSlotValue(PDA_Warlock_Hands, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Waist, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Legs, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Feet, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Finger1, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Finger2, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Trinket1, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Trinket2, 0, 0, 0, 0, 0, 0)

	PDA_Warlock_SetSlotValue(PDA_Warlock_MainHand, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_OffHand, 0, 0, 0, 0, 0, 0)
	PDA_Warlock_SetSlotValue(PDA_Warlock_Wand, 0, 0, 0, 0, 0, 0)
	
	PDA_Warlock_SetSlotValue(PDA_Warlock_SetBonus, 0, 0, 0, 0, 0, 0)
end

function PDA_Warlock_ReturnSum(valueName)
	local sum = 0
	sum = sum + PDA_Warlock_Head[valueName]:GetValue()
	sum = sum + PDA_Warlock_Neck[valueName]:GetValue()
	sum = sum + PDA_Warlock_Shoulder[valueName]:GetValue()
	sum = sum + PDA_Warlock_Back[valueName]:GetValue()
	sum = sum + PDA_Warlock_Chest[valueName]:GetValue()
	sum = sum + PDA_Warlock_Shirt[valueName]:GetValue()
	sum = sum + PDA_Warlock_Tabard[valueName]:GetValue()
	sum = sum + PDA_Warlock_Wrist[valueName]:GetValue()

	sum = sum + PDA_Warlock_Hands[valueName]:GetValue()
	sum = sum + PDA_Warlock_Waist[valueName]:GetValue()
	sum = sum + PDA_Warlock_Legs[valueName]:GetValue()
	sum = sum + PDA_Warlock_Feet[valueName]:GetValue()
	sum = sum + PDA_Warlock_Finger1[valueName]:GetValue()
	sum = sum + PDA_Warlock_Finger2[valueName]:GetValue()
	sum = sum + PDA_Warlock_Trinket1[valueName]:GetValue()
	sum = sum + PDA_Warlock_Trinket2[valueName]:GetValue()

	sum = sum + PDA_Warlock_MainHand[valueName]:GetValue()
	sum = sum + PDA_Warlock_OffHand[valueName]:GetValue()
	sum = sum + PDA_Warlock_Wand[valueName]:GetValue()
	
	sum = sum + PDA_Warlock_SetBonus[valueName]:GetValue()
	
	if (PDA_Warlock_SupremeFlaskBuff:GetChecked()) then sum = sum + PDA_Warlock_SupremeFlaskBuff[valueName] end
	if (PDA_Warlock_CerebralCortexBuff:GetChecked()) then sum = sum + PDA_Warlock_CerebralCortexBuff[valueName] end
	if (PDA_Warlock_ArcaneElixirBuff:GetChecked()) then sum = sum + PDA_Warlock_ArcaneElixirBuff[valueName] end
	if (PDA_Warlock_ShadowElixirBuff:GetChecked()) then sum = sum + PDA_Warlock_ShadowElixirBuff[valueName] end
	if (PDA_Warlock_RunnTummBuff:GetChecked()) then sum = sum + PDA_Warlock_RunnTummBuff[valueName] end
	
	if (PDA_Warlock_OnyxiaBuff:GetChecked()) then sum = sum + PDA_Warlock_OnyxiaBuff[valueName] end
	if (PDA_Warlock_SavvyBuff:GetChecked()) then sum = sum + PDA_Warlock_SavvyBuff[valueName] end
	if (PDA_Warlock_SongflowerBuff:GetChecked()) then sum = sum + PDA_Warlock_SongflowerBuff[valueName] end
	
	if (PDA_Warlock_MOTWBuff:GetChecked()) then sum = sum + PDA_Warlock_MOTWBuff[valueName] end
	if (PDA_Warlock_ArcaneBrillianceBuff:GetChecked()) then sum = sum + PDA_Warlock_ArcaneBrillianceBuff[valueName] end
	
	return sum
end

function PDA_Warlock_CalculateAll()
	local totalInt = PDA_Warlock_ReturnSum("Int")
	local totalHit = PDA_Warlock_ReturnSum("Hit") / 100
	local totalCrit = PDA_Warlock_ReturnSum("Crit") / 100
	local totalSP = PDA_Warlock_ReturnSum("SP")
	local totalSSP = PDA_Warlock_ReturnSum("SSP")
	local totalFSP = PDA_Warlock_ReturnSum("FSP")
	
	local race = UnitRace("Player"):lower()
	if (race:find("gnome")) then totalInt = totalInt + 119
	elseif (race:find("human")) then totalInt = totalInt + 110
	elseif (race:find("orc")) then totalInt = totalInt + 107
	elseif (race:find("undead")) then totalInt = totalInt + 108 end
	
	if (PDA_Warlock_ZandalarBuff:GetChecked()) then totalInt = totalInt * 1.15 end
	
	totalCrit = totalCrit + 0.0183 + (totalInt / 60.6 / 100)
	totalHit = totalHit + 0.83
	
	local percentDamageBonus = 0
	local critModifier = 0.50
	
	if (PDA_Warlock_ShadowMasteryTalent:GetChecked()) then percentDamageBonus = percentDamageBonus + 0.10 end
	if (PDA_Warlock_DemonicSacrificeTalent:GetChecked()) then percentDamageBonus = percentDamageBonus + 0.15 end
	if (PDA_Warlock_MasterDemonologistTalent:GetChecked()) then percentDamageBonus = percentDamageBonus + 0.10 end
	if (PDA_Warlock_SoulLinkTalent:GetChecked()) then percentDamageBonus = percentDamageBonus + 0.03 end
	if (PDA_Warlock_DevastationTalent:GetChecked()) then totalCrit = totalCrit + 0.05 end
	if (PDA_Warlock_RuinTalent:GetChecked()) then critModifier = critModifier + 0.50 end
	if (PDA_Warlock_BaneTalent:GetChecked()) then
		PDA_Warlock_SpellFrame.CastTime.Value:SetText(2.5)
	else
		PDA_Warlock_SpellFrame.CastTime.Value:SetText(3)
	end
	
	local baseDamage = tonumber(PDA_Warlock_SpellFrame.BaseDamage.Value:GetText())
	local castTime = tonumber(PDA_Warlock_SpellFrame.CastTime.Value:GetText())
	local coefficient = tonumber(PDA_Warlock_SpellFrame.Coefficient.Value:GetText())
	
	-- I SEE YOU ARE DIGGING THROUGH MY SOURCE CODE ^^, HERE HAVE THE GRAND FORMULA --
	local dps = ((baseDamage + (totalSP + totalSSP) * coefficient) / castTime) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit)
	local plusIntDps = ((baseDamage + (totalSP + totalSSP) * coefficient) / castTime) * (1 + percentDamageBonus) * (1 + (totalCrit + 1 / 60.6 / 100) * critModifier) * (totalHit)
	local plusHitDps = ((baseDamage + (totalSP + totalSSP) * coefficient) / castTime) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit + 0.01)
	local plusCritDps = ((baseDamage + (totalSP + totalSSP) * coefficient) / castTime) * (1 + percentDamageBonus) * (1 + (totalCrit + 0.01) * critModifier) * (totalHit)
	local plusSPDps = ((baseDamage + (totalSP + 1 + totalSSP) * coefficient) / castTime) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit)
	local plusSSPDps = ((baseDamage + (totalSP + totalSSP + 1) * coefficient) / castTime) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit)
	local intValue = (plusIntDps - dps) / dps
	local hitValue = (plusHitDps - dps) / dps
	local critValue = (plusCritDps - dps) / dps
	local spValue = (plusSPDps - dps) / dps
	local sspValue = (plusSSPDps - dps) / dps
	
	PDA_Warlock_TotalInt.Value:SetText(totalInt)
	PDA_Warlock_IntValue.Value1:SetText(string.format("%0.2f", intValue * 100) .. "%")
	PDA_Warlock_IntValue.Value2:SetText(string.format("%0.2f", intValue / spValue))
	PDA_Warlock_TotalHit.Value:SetText(string.format("%0i", totalHit * 100) .. "%")
	PDA_Warlock_HitValue.Value1:SetText(string.format("%0.2f", hitValue * 100) .. "%")
	PDA_Warlock_HitValue.Value2:SetText(string.format("%0.2f", hitValue / spValue))
	PDA_Warlock_TotalCrit.Value:SetText(string.format("%0i", totalCrit * 100) .. "%")
	PDA_Warlock_CritValue.Value1:SetText(string.format("%0.2f", critValue * 100) .. "%")
	PDA_Warlock_CritValue.Value2:SetText(string.format("%0.2f", critValue / spValue))
	PDA_Warlock_TotalSP.Value:SetText(totalSP)
	PDA_Warlock_SPValue.Value1:SetText(string.format("%0.2f", spValue * 100) .. "%")
	PDA_Warlock_SPValue.Value2:SetText(1)
	PDA_Warlock_TotalSSP.Value:SetText(totalSSP)
	PDA_Warlock_SSPValue.Value1:SetText(string.format("%0.2f", sspValue * 100) .. "%")
	PDA_Warlock_SSPValue.Value2:SetText(1)
	PDA_Warlock_TotalFSP.Value:SetText(totalFSP)
	PDA_Warlock_FSPValue.Value1:SetText(0 .. "%")
	PDA_Warlock_FSPValue.Value2:SetText(1)
	PDA_Warlock_DPSFrame.Title:SetText("DPS: " .. dps)
end